//#include "define.h"

void motor_open() {
  pinMode(PIN_DIR_L, OUTPUT);
  pinMode(PIN_PWM_L, OUTPUT);
  pinMode(PIN_DIR_R, OUTPUT);
  pinMode(PIN_PWM_R, OUTPUT);
  pinMode(PIN_SM, OUTPUT);
  pinMode(PIN_ARM_DIR, OUTPUT);
  pinMode(PIN_ARM_PWM, OUTPUT);
  analogWrite(PIN_PWM_L, 0);
  analogWrite(PIN_PWM_R, 0);
  analogWrite(PIN_SM, 0);
  analogWrite(PIN_ARM_PWM, 0);
}

void motor_set(int pwm_l, int pwm_r) {
  // モータ回転方向の補正
  pwm_l *= -1;
  //pwm_r *= -1;
  
  if (pwm_l >  255) pwm_l =  255;
  if (pwm_l < -255) pwm_l = -255;
  if (pwm_r >  255) pwm_r =  255;
  if (pwm_r < -255) pwm_r = -255;
  
  /*run_state_t state;
  if(state == LNT){
    if(pwm_l <= -50){
      pwm_l = -50;
    }
    if(pwm_r <= -50){
      pwm_r = -50;
    }
  }
  */
  
  if (pwm_l > 0) {
    digitalWrite(PIN_DIR_L, HIGH);
    write_mute_pwm(PIN_PWM_L,pwm_l);//analogWrite(PIN_PWM_L, pwm_l);
  } else {
    digitalWrite(PIN_DIR_L, LOW);
    write_mute_pwm(PIN_PWM_L,-pwm_l);//analogWrite(PIN_PWM_L, -pwm_l);
  }
  if (pwm_r > 0) {
    digitalWrite(PIN_DIR_R, HIGH);
    write_mute_pwm(PIN_PWM_R,pwm_r);//analogWrite(PIN_PWM_R, pwm_r);
  } else {
    digitalWrite(PIN_DIR_R, LOW);
    write_mute_pwm(PIN_PWM_R,-pwm_r);//analogWrite(PIN_PWM_R, -pwm_r);
  }
  return;
}

void motor_a_set(int pwm_a) {
  pwm_a *= -1;
  if (pwm_a >  255) pwm_a =  255;
  if (pwm_a < -255) pwm_a = -255;
  if (pwm_a > 0) {
    digitalWrite(PIN_ARM_DIR, HIGH);
    write_mute_pwm(PIN_ARM_PWM,pwm_a);//analogWrite(PIN_ARM_PWM, pwm_a);
  } else {
    digitalWrite(PIN_ARM_DIR, LOW);
    write_mute_pwm(PIN_ARM_PWM,pwm_a);//analogWrite(PIN_ARM_PWM, -pwm_a);
  }
}
