  //#include "define.h"
Servo myservo;
void slave() {
  double speed, dist, dist_l, dist_r;
  static int Lstate = 0;
  run_state_t state;
  command_data_t command_data;
  init_status_indicator();//11/28追加
  myservo.attach(10);
  while (1) {
    //set_status_indicator(state);//12/03追加

    if (raspi_receive(&command_data) == 0) {
      Lstate = ((command_data.val[0] & 0xf0)>>4);
      set_status_indicator(Lstate);
      switch ((int)command_data.val[0] & 0x0f) {
      case 0:
        run_ctrl_set(STP, 0, 0);
        //set_status_indicator(Lstate);//12/27追加
        run_ctrl_get(&state, &speed, &dist);
        break;
      case 1:
        run_ctrl_set(STR, command_data.val[1], command_data.val[2]);
        //raspi_send(command_data);
        break;
      case 2:
        //LNT_frag = 0;
        run_ctrl_set(ROT, command_data.val[1], command_data.val[2]);
        //raspi_send(command_data);
        break;
      case 3:
        //LNT_frag = 1;
        linetrace_start(LNT, command_data.val[1], command_data.val[2]);
        //if(command_data.val[2] == 1234){
        //  bcorrection_frag = 1;
        //}
        //set_status_indicator(INSPEC);//11/28追加
        break;
      case 4:
        run_ctrl_set(LNT_RS, command_data.val[1], command_data.val[2]);
        break;
      case 5:
        arm_ctrl_set(ARM, command_data.val[1], command_data.val[2]);
        //set_status_indicator(WASH);//11/28追加
        break;
      case 6:
        body_ctrl_set(ARM_PID, command_data.val[1], command_data.val[2]);
        //set_status_indicator(WASH);//11/28追加
        break;
      case 7:
        //get_height();
        command_data.val[2] = 0;
        command_data.val[0] = 0;
        command_data.val[1] = (short)(get_height());
        raspi_send(command_data);
        break;
      case 8:

        switch ((int)command_data.val[1]) {
        case 1:
          myservo.attach(10);
          myservo.write(150);//正面
          delay(600);
          myservo.detach();
          break;
        case 2:
          myservo.attach(10);
          myservo.write(42);//横
          delay(600);
          myservo.detach();
          break;
        }
      case 9:
        //set_status_indicator(Lstate);//12/27追加
        break;

      case 10:
        //run_ctrl_set(STR, command_data.val[1], command_data.val[2]);
        run_ctrl_get(&state, &speed, &dist);
        command_data.val[0] = state;//((state == STR) ? 1 : (state == ROT) ? 2 : (state == LNT) ? 3 : (state == LNT_RS) ? 4 : (state == ARM) ? 5 : (state == ARM_PID) ? 6 : 0);
        command_data.val[1] = (short)speed;
        command_data.val[2] = (short)dist;
        raspi_send(command_data);
        break;
      case 11:
        distance_get(&dist_l, &dist_r);
        command_data.val[0] = (short)dist_l;
        command_data.val[1] = (short)dist_r;
        raspi_send(command_data);
        break;
      case 12://エンコーダーを一時停止する
        encoder_stop();
        break;
      case 13://エンコーダを再開
        encoder_resume();
        break;
      case 14:
        command_data.val[0] = (short)(io_get_batt() * 100.0);
        raspi_send(command_data);
      default:
        break;
      }
    }
    //set_status_indicator((command_data.val[0] & 0x00f0 >> 4));
    if(state == STP){
      //set_status_indicator(Lstate);
      //run_ctrl_execute();
    }

    if (state == ARM) {
      run_ctrl_execute();//走行制御実行
      arm_ctrl_execute();//アームのPID制御
      if (0) { //ゼロ点スイッチが推されたら,停止
        run_state_t state = STP;//エンコーダ制御でゼロ点復帰に使用、抵抗器式に変わったため不使用
      }

    }
    else if (state == ARM_PID) {
      run_ctrl_execute();
      if(state == ARM_PID){
        hight_ctrl_execute();//高さとそれに依存する走行のPID制御
      }
    }
    else if (state == LNT) {
      if(run_state == STP)break;
      photoreflector();
      run_ctrl_execute();
      //if(state != STP){
      linetrace_execute();
      //}
      if(0){//bcorrection_frag == 1){
        run_ctrl_set(STP,0,0);
        motor_set(0,0);
        state = STP;//補正終了時に止まる（特例）
        bcorrection_frag = 0;
        break;
      }
      if (imode_turn == 1) {
        encoder_stop();
        run_ctrl_set(ROT, 30, 94);
        while (run_state == ROT) {
          run_ctrl_execute();
          vel_ctrl_execute();
          delay(T_CTRL);
        }
        //linetrace_start(LNT,0,command_data.val[2] - dist_re);
        encoder_resume();
        bcorrection_frag=1;
      }
      if (imode_turn == 0) {
        vel_ctrl_execute();
      }
      if (imode_turn == 2) {
        run_ctrl_set(STR, 10, 17);
        while (run_state == STR) {
          run_ctrl_execute();
          vel_ctrl_execute();
          delay(T_CTRL);
        }
        run_ctrl_set(ROT, 30, 94);
        encoder_stop();
        while (run_state == ROT) {
          run_ctrl_execute();
          vel_ctrl_execute();
          delay(T_CTRL);
        }
        //linetrace_start(LNT,0,command_data.val[2] - dist_re);
        encoder_resume();

      }
      if (imode_turn == 3) {
        run_ctrl_set(STR, 10, 17);
        while (run_state == STR) {
          run_ctrl_execute();
          vel_ctrl_execute();
          delay(T_CTRL);
        }
        run_ctrl_set(ROT, 30, -94);
        encoder_stop();
        while (run_state == ROT) {
          run_ctrl_execute();
          vel_ctrl_execute();
          delay(T_CTRL);
        }
        //linetrace_start(LNT,0,command_data.val[2] - dist_re);
        encoder_resume();

      }

      //      if(0){//ゼロ点スイッチが推されたら,停止
      //         run_state_t state = STP;//エンコーダ制御でゼロ点復帰に使用、抵抗器式に変わったため不使用
      //      }
    }
    else { //走行
      run_ctrl_execute();
      vel_ctrl_execute();
    }


    delay(T_CTRL);
  }
}




