//#include "define.h"
//#include "arm_ctrl.h"

void test_encoder() {
  long enc_l, enc_r;
  char str[100];

  while (1) {
    encoder_get(&enc_l, &enc_r);
    sprintf(str, "enc_l = %6ld, enc_r = %6ld\n", enc_l, enc_r);
    Serial.print(str);
    delay(T_CTRL);
    Serial.print(pwm_r);
    Serial.println(pwm_l);
  }
}

void test_distance() {
  double dist_l, dist_r;
  char str[100], str_l[10], str_r[10];

  while (1) {
    distance_get(&dist_l, &dist_r);
    sprintf(str, "dist_l = %s, dist_r = %s\n",
    dtostrf(dist_l, 6, 1, str_l),
    dtostrf(dist_r, 6, 1, str_r));
    Serial.print(str);
    delay(T_CTRL);
  }
}

void test_line_rs(){
  run_ctrl_set(LNT_RS,0,0);
  while(1){
    run_ctrl_execute();
    vel_ctrl_execute();
    Serial.print("err_r: ");
    Serial.print(line_err_r);
    Serial.print("\terr_l: ");
    Serial.print(line_err_l
      );
    Serial.print("\tc: ");
    Serial.println(c);
    delay(T_CTRL);
    while(run_state == STP){
      Serial.println("fuckin' bitch!!!");
      delay(T_CTRL);
    }
  }
}
void test_motor(int pwm_l, int pwm_r) {


  while (pres_val < pres_val_ul) {
    pressure_get();
    motor_set(pwm_l, pwm_r);
    delay(T_CTRL);
    Serial.print(pwm_r);
    Serial.println(pwm_l);
  }
  motor_set(-pwm_r, -pwm_r);
}

void test_vel_ctrl(double vel_l, double vel_r) {
  int i = 0;
  char str[100], str_l[10], str_r[10];
  char str_v[10];
  double variance ;
  static long count = 0;
  static int count_max = 1000; //10秒

  vel_ctrl_set(vel_l, vel_r);

  while (1) {
    pressure_get();
    vel_ctrl_execute();
    if (i >= 10) {
      vel_ctrl_get(&vel_l, &vel_r);
      vel_ctrl_get_vari(&variance);
      sprintf(str, "vel_l = %s, vel_r = %s   variance= %s \n",
      dtostrf(vel_l, 6, 1, str_l),
      dtostrf(vel_r, 6, 1, str_r),
      dtostrf(variance, 6, 1, str_v));
      Serial.print(str);
      i = 0;
    }

    i++;
    delay(T_CTRL);
    count++;
    Serial.print(pwm_r);
    Serial.println(pwm_l);
    if ( pres_val > pres_val_ul ) break;//count > count_max
  }
  run_state = STP;
}

void test_run_ctrl(run_state_t state, double speed, double dist) {
  int i = 0;
  char str[100], str_dist[10], str_speed[10];

  run_ctrl_set(state, speed, dist);
  while (1) {
    run_ctrl_execute();
    vel_ctrl_execute();
    if (i >= 10) {
      run_ctrl_get(&state, &speed, &dist);
      sprintf(str, "state = %s, speed = %s, dist = %s\n",
      ((state == STR) ? "STR" : (state == ROT) ? "ROT" : (state == ARM) ? "ARM" : (state == ARM_PID) ? "ARM_PID" : "STP"),
      dtostrf(speed, 6, 1, str_speed),
      dtostrf(dist, 6, 1, str_dist));
      Serial.print(str);
      Serial.print(vel_ref);
      i = 0;
    }
    i++;
    //if( state == STP ) break;
    Serial.print(pwm_r);
    Serial.println(pwm_l);
    //    Serial.print(pres_val);
    //    Serial.print("\t");
    //    Serial.print(vel_mod);
    //    Serial.print("\t");
    //    Serial.println(sign);
    delay(T_CTRL);
  }
}

void test_batt() {
  double batt;
  char str[100], str_batt[10];

  while (1) {
    batt = io_get_batt();
    sprintf(str, "volt = %s\n", dtostrf(batt, 4, 2, str_batt));
    Serial.print(str);
    delay(T_CTRL);
  }
}

void test_decode() {
  command_data_t command_data = {
    30000, -255, 0                  };
  middle_data_t  middle_data;
  serial_data_t  serial_data;

  while (1) {
    middle_data  = raspi_encode2(command_data);
    serial_data  = raspi_encode1(middle_data);
    middle_data  = raspi_decode1(serial_data);
    command_data = raspi_decode2(middle_data);
    Serial.println(command_data.val[0], HEX);
    Serial.println(command_data.val[1]);
    Serial.println(command_data.val[2]);
    delay(1000);
  }
}

void test_resister() {
  Serial.begin(115200);
  while (1) {
    //Serial.println("動いた!!!!");
    delay(100);
    get_deg_arm();//角度位置読み取り
    get_height();//高さ読み取り
    //get_body_dist(&body_dist, &body_a_dist);
    Serial.print(v_out);
    Serial.print("\t");
    Serial.print(arm_voltage);
    Serial.print("\t");
    Serial.print(deg_arm);
    Serial.print("\t");
    //Serial.println(deg_arm_r);
    //    Serial.print("\t");
    Serial.println(height);
    //    Serial.print("\t");
    //    Serial.println(body_dist);
  }
}
void test_a_motor(int pwm_a) {
  motor_a_set(pwm_a);
  while (1) {
    delay(T_CTRL);
  }
}
void test_arm_ctrl() {
  Serial.begin(115200);
  arm_ctrl_set(ARM, 50, 700);//（状態、速度（適当）、角度位置）
  while (1) {
    run_ctrl_execute();//走行制御実行
    if (run_state == STP) {
      while (1) {
        Serial.println("お終わりじゃボケ");
      }
    }
    arm_ctrl_execute();//アームのPID制御
    Serial.print(deg_arm);
    Serial.print("\t");
    Serial.print(deg_ref);
    Serial.print("\t");
    Serial.print(c);
    Serial.print("\t");
    Serial.print(pwm_a);
    Serial.print("\t");
    Serial.println(err_sum_a);
    delay(T_CTRL);
  }
}

void test_wash() {
  Serial.begin(9600);
  arm_ctrl_set(ARM, 50, 70);//（状態、速度（適当）、角度位置）
  while (run_state == ARM) {
    run_ctrl_execute();//走行制御実行
    arm_ctrl_execute();//アームのPID制御
    //Serial.print(str);
    Serial.print("\t");
    Serial.print(deg_curr);
    Serial.print("\t");
    Serial.print(deg_ref);
    Serial.print("\t");
    Serial.print(c);
    Serial.print("\t");
    Serial.println(pwm_a);
    //Serial.print("\t");
    //Serial.println(err_sum_a);
    delay(T_CTRL);
  }
  arm_ctrl_set(ARM, 50, 50);//（状態、速度（適当）、角度位置）
  while (run_state == ARM) {
    run_ctrl_execute();//走行制御実行
    arm_ctrl_execute();//アームのPID制御
    Serial.print(deg_curr);
    Serial.print("\t");
    Serial.print(deg_ref);
    Serial.print("\t");
    Serial.print(c);
    Serial.print("\t");
    Serial.println(pwm_a);
    //Serial.print("\t");
    //Serial.println(err_sum_a);
    delay(T_CTRL);
  }
}

void test_height() {
  Serial.begin(115200);
  Serial.println(run_state);
  //get_height();
  body_ctrl_set(ARM_PID, 5, 900);//（状態、速度（適当）、角度位置）
  while (1) {
    run_ctrl_execute();//走行制御実行
    if (run_state == STP) {
      //encoder_reset();
      break;
    }
    hight_ctrl_execute();//アームと機体のPID制御
    //Serial.print(height);
    //Serial.print("\theight_ref_vari:");
    //Serial.print(height_ref_vari);
    //Serial.print("\tdeg_arm:");
    //Serial.print(deg_arm);
    //Serial.print("\tdist_curr_r:");
    //    Serial.print(get_adjast(1100.0));
    //    Serial.print("\t");
    //Serial.print(dist_curr_l_h);
    //Serial.print("\tbody_curr:");
    //Serial.print(body_curr);
    //Serial.print("\t");
    //    Serial.print(dist_err);
    //    Serial.print("\t");
    //    Serial.print(vel_ref_r_h);
    //    Serial.print("\t");
    //    Serial.print(vel_ref_l_h);
    //    Serial.print("\t");
    Serial.print(pwm_r);
    Serial.print("\t");
    Serial.print(pwm_l);
    Serial.print("\t");
    Serial.print(pwm_a);
    Serial.print("\t");
    Serial.print(ratio);
    Serial.print("\t");
    Serial.print(c);
    Serial.print("\t");
    Serial.println(pres_val);
    delay(T_CTRL);
  }

  body_ctrl_set(ARM_PID, 5, 1000);//（状態、速度（適当）、角度位置）
  while (1) {
    run_ctrl_execute();//走行制御実行
    if (run_state == STP) {
      break;
    }
    hight_ctrl_execute();//アームと機体のPID制御

    //    Serial.print(state);
    //    Serial.print("\t");
    //Serial.print(height);
    //Serial.print("\theight_ref_vari:");
    //Serial.print(height_ref_vari);
    //Serial.print("\tdeg_arm:");
    //Serial.print(deg_arm);
    //Serial.print("\tdist_curr_r:");
    //    Serial.print(get_adjast(1100.0));
    //    Serial.print("\t");
    //Serial.print(dist_curr_l_h);
    //Serial.print("\tbody_curr:");
    //Serial.print(body_curr);
    //Serial.print("\t");
    //    Serial.print(dist_err);
    //    Serial.print("\t");
    //    Serial.print(vel_ref_r_h);
    //    Serial.print("\t");
    //    Serial.print(vel_ref_l_h);
    //    Serial.print("\t");
    Serial.print(pwm_r);
    Serial.print("\t");
    Serial.print(pwm_l);
    Serial.print("\t");
    Serial.print(pwm_a);
    Serial.print("\t");
    Serial.print(ratio);
    Serial.print("\t");
    Serial.print(c);
    Serial.print("\t");
    Serial.println(pres_val);
    delay(T_CTRL);
  }
}

void test_state_light() {
  init_status_indicator();
  while (1) {
    set_status_indicator(WAIT);
    delay(1000);
    set_status_indicator(JUDGE);
    delay(1000);
    set_status_indicator(INSPEC);
    delay(1000);
    set_status_indicator(WASH);
    delay(1000);
    while (1) {
      set_status_indicator(HOMING);
    }
  }
}

void test_adjast() {
  Serial.begin(115200);
  while (1) {
    get_adjast(1000);
    Serial.println(adjast);

  }
}
void test_fot() {
  //linetrace_open();
  photoreflector();
  for (int i = 0; i < 7; i++) {
    delay(10);
    Serial.print(inow[i]);
    Serial.print(",");

  }
  Serial.println();
}

void test_line() {
  //linetrace_open();
  LNT_frag = 1;
  linetrace_start(LNT, 80, 536);
  while (1) {
    photoreflector();
    run_ctrl_execute();
    linetrace_execute();
    if(imode_turn == 0){
      vel_ctrl_execute();
    }
    if (imode_turn == 1) {
      encoder_stop();
      run_ctrl_set(ROT, 15, -90);
      while (run_state == ROT) {
        run_ctrl_execute();
        vel_ctrl_execute();
        Serial.println("fucking 1 right turn");
        //        if(bcorrection_frag==1){
        //          run_ctrl_set(STP,0,0);
        //          motor_set(0,0);
        //          vel_ctrl_set(0,0);
        //          //bcorrection_frag=0;
        //          break;
        //        }

      }
      encoder_resume();
    }
    if (imode_turn == 2) {
      run_ctrl_set(STR, 10, 17);
      while (run_state == STR) {
        run_ctrl_execute();
        vel_ctrl_execute();
        Serial.print(dist_curr);
        Serial.println("fucking 2 adjust str");
      }
      encoder_stop();
      run_ctrl_set(ROT, 30, 94);
      while (run_state == ROT) {
        run_ctrl_execute();
        vel_ctrl_execute();
        Serial.print(dist_curr);
        Serial.println("fucking 2 left turn");
      }
      run_ctrl_set(STR, 10, 100);
      while (run_state == STR) {
        run_ctrl_execute();
        vel_ctrl_execute();
        Serial.print(dist_curr);
        Serial.println("fucking 2 adjust str");
      }
      encoder_resume();
    }
    if (imode_turn == 3) {
      run_ctrl_set(STR, 10, 17);
      while (run_state == STR) {
        run_ctrl_execute();
        vel_ctrl_execute();
        Serial.print(dist_curr);
        Serial.println("fucking 3 adjust turn");
      }
      encoder_stop();
      run_ctrl_set(ROT, 30, -94);
      while (run_state == ROT) {
        run_ctrl_execute();
        vel_ctrl_execute();
        Serial.print(dist_curr);
        Serial.println("fucking 3 left turn");
      }
      run_ctrl_set(STR, 10, 100);
      while (run_state == STR) {
        run_ctrl_execute();
        vel_ctrl_execute();
        Serial.print(dist_curr);
        Serial.println("fucking 2 adjust str");
      }
      encoder_resume();
    }
    //motor_set(pwm_l, pwm_r);//11/27追加

    //  Serial.print(inow[3]);
    //  Serial.print(",");
    //  Serial.print(inow[4]);
    //  Serial.println(",");


    for (int i = 0; i < 7 ; i++) {
      //Serial.print(inow[i]);
      //Serial.print(",");
      Serial.print(ierr[i]);
      Serial.print(",");

    }
    //Serial.println("");


    Serial.print(pwm_r);
    Serial.print(",");
    Serial.println(pwm_l);

    //  Serial.println(imode_restart);
    //  Serial.println(imode_str);
    //  Serial.println(imode_turn);
    //  Serial.println(ierrstop);
    //  Serial.println(fPID_P_R);
    //  Serial.println(fPID_D_R);
    //  Serial.println(fPID_P_L);
    //  Serial.println(fPID_D_L);
    //Serial.println(iExc_pt);
    //Serial.print("\t");
    //Serial.print(dist_curr);//kokkara
    //Serial.print("\t");
    //Serial.print(pwm_r);
    //Serial.print(",");
    //Serial.print(pwm_l);//kokomo
    //Serial.print("\tadc: ");
    //Serial.print(get_add_dist_curr());
    //Serial.print("\t");
    if(imode_turn != 0){
      Serial.print("turn:");
      Serial.print(imode_turn);
    }
    if(imode_str != 0){
      Serial.print("str:");
      Serial.println(imode_str);
    }
    if(imode_restart != 0){
      Serial.print("restart:");
      Serial.print(imode_restart);
    }
    //Serial.print("\t");
    Serial.print("iStep:");
    Serial.println(iStep);
    delay(100);//delayついか
    /*if (run_state == STP && true != bcorrection_frag) {
     run_ctrl_execute();
     break;
     }*/
    //    if(bcorrection_frag == 1){
    //      bcorrection_frag = 0;
    //      break;
    //    }
  }
  //  while (1) {
  //    Serial.println("fuck you");
  //  }
  delay(T_CTRL);
}

void test_linecalib() {
  Serial.begin(115200);
  //run_ctrl_set(ROT, 50, 360);
  //while (run_state == ROT) {
  //run_ctrl_execute();
  //vel_ctrl_execute();
  photo_calibration();
  for (int i = 0; i < 7; i++) {
    //Serial.print(inow[i]);
    Serial.print(ithreshold[i]);
    Serial.print("\t");
  }
  Serial.println();
  delay(100);//delay(T_CTRL);

  //}
  //delay(1000);
  //  while (1) {
  //    photoreflector();
  //    run_ctrl_execute();
  //    linetrace_execute();
  //    if (imode_turn == 1) {
  //      run_ctrl_set(ROT, 15, -90);
  //      while (run_state == ROT) {
  //        run_ctrl_execute();
  //        vel_ctrl_execute();
  //      }
  //      //bcorrection_frag=1
  //    }
  //    if (imode_turn == 2) {
  //      run_ctrl_set(STR, 5, 13);
  //      while (run_state == STR) {
  //        run_ctrl_execute();
  //        vel_ctrl_execute();
  //      }
  //      run_ctrl_set(ROT, 15, 90);
  //      while (run_state == ROT) {
  //        run_ctrl_execute();
  //        vel_ctrl_execute();
  //      }
  //    }
  //    if (imode_turn == 3) {
  //      run_ctrl_set(STR, 5, 13);
  //      while (run_state == STR) {
  //        run_ctrl_execute();
  //        vel_ctrl_execute();
  //      }
  //      run_ctrl_set(ROT, 15, -90);
  //      while (run_state == ROT) {
  //        run_ctrl_execute();
  //        vel_ctrl_execute();
  //      }
  //    }
  //    //    Serial.print(pwm_r);
  //    //    Serial.print(",");
  //    //    Serial.println(pwm_l);
  //    for (int i = 0; i < 7 ; i++) {
  //      Serial.print(inow[i]);
  //      Serial.print(",");
  //    }
  //    Serial.println(imode_restart);
  //    Serial.println(imode_str);
  //    Serial.println(imode_turn);
  //    delay(T_CTRL);


  //}
  //run_state = ROT;
  //run_ctrl_execute();
  //photo_calibration();
  //run_state = STP;
  //  if (istop_linetrace = 1) {
  //    run_state = STP;
  //    dist_current = 0;
  //  }

}

void test_servo() {
  pinMode(10,OUTPUT);
  Servo myservo;
  myservo.attach(10);
  while (1) {
    myservo.write(150);//正面
    delay(1000);
    myservo.write(42);
    delay(1000);
  }
  //myservo.write(90);
}









