

static double deg_prev_a = 0.0;//アーム用
static double err_prev_a  = 0.0;//アーム用
static double err_sum_a   = 0.0;//アーム用
static double deg_ref_a   = 0.0;//角度指令値


static double vari = 0.0;
static double varian = 0.0;
static long count = 1;

void arm_ctrl_execute() {
  const double Kp = 40.0; //0.5
  const double Ki = 1.0; //
  const double Kd = 100.0;

  double err_curr_a;

  //角度読み取り
  get_deg_arm();

  //誤差の計算
  err_curr_a = deg_ref_a - deg_arm;
  if( err_sum_a + err_curr_a >= -100 && err_sum_a + err_curr_a <= 100){
    err_sum_a += err_curr_a;
  }
  
  

  vari += abs(err_curr_a);
  varian = vari / count;
  count ++;
  //PID制御
  pwm_a = Kp * err_curr_a + Ki * err_sum_a + Kd * (err_curr_a - err_prev_a);
  /*if(pwm_a <= 0){
    pwm_a = pwm_a * -1;
    
  }*/
  // 速度指令値 = 0 なら強制的に停止
  //if (deg_ref_a == 0.0) pwm_a = 0;
  
  motor_a_set(-pwm_a);
  //Serial.print(pwm_a);
  
  deg_prev_a = deg_arm;
  err_prev_a  = err_curr_a;
}

void deg_ctrl_a_set(double deg_a) {
  deg_ref_a = deg_a;
}

void deg_ctrl_a_get(double *deg_a) {
  *deg_a = deg_arm;
}

void deg_ctrl_a_reset() {
  deg_prev_a = 0.0;
  err_prev_a  = 0.0;
  err_sum_a   = 0.0;
  deg_ref_a   = 0.0;

  motor_a_set(0);
  //encoder_a_reset();
}
