//#include "arm_ctrl.h"


static double err_prev_h   = 0.0;//位置D制御用、前エラー値
static double err_prev_b   = 0.0;//速度D制御用、前エラー値
static double err_sum_h    = 0.0;//位置制御
static double err_sum_b    = 0.0;
static double deg_prev_h = 0.0;//高さ前の値
//static double dist_ref  = 0.0;//高さ指令値
static double deg_curr_h = 0.0;//高さ現在地

static double micro_deg_ref = 0.0;
static double deg_ref_h = 0.0;

static double body_ref  = 0.0;
static double body_prev  = 0.0;//機体の現在地(アーム動かす前)
static double body_curr = 0.0;//機体の現在地(アーム動かした後)

static double vel_ref_l_h   = 0.0;//
static double vel_ref_r_h   = 0.0;//
static double vel_curr_l_h  = 0.0;//
static double vel_curr_r_h  = 0.0;//機体の速度P制御用の変数たち
static double dist_prev_l_h = 0.0;//
static double dist_prev_r_h = 0.0;//

static double err_sum_l_h   = 0.0;//機体のI速度制御
static double err_sum_r_h   = 0.0;//
static double err_prev_l_h  = 0.0;//
static double err_prev_r_h  = 0.0;//

static double vari_h = 0.0;//
static double varian_h = 0.0;//ゲイン調整用
static long count_h = 1;//

static double err_curr_h;

static double dist_curr_l_h, dist_curr_r_h, err_curr_l_h, err_curr_r_h;

static double pres_err = 0.0;
static double pres_err_prev = 0.0;
static double pres_err_sum = 0.0;

static double x, y = 0.0;

static double height_ref_vari = 0.0;
static double height_ref = 0.0;
static double dist_curr_h = 0.0;
void hight_ctrl_execute() {
  //PIDゲイン

  double d_r, d_l;

  
  const double Kp_a = 10.0;//10.0
  const double Ki_a = 0.6;//0.5
  const double Kd_a = 0.8;//0.0
  const double Kp_b = 100.0; //100
  const double Ki_b = 0.1; //0.1
  const double Kd_b = 0.0; //0.0


  //int pwm_a, pwm_r, pwm_l;


  get_deg_arm();//角度取得
  pressure_get();//圧力取得
  get_height();//高さ







  /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  /*pres_err = 50 - pres_val;

    if ( pres_err_sum + pres_err >= -100 && pres_err_sum + pres_err <= 100) {
    pres_err_sum += pres_err;
    }


    x = Al * cos(deg_ref_h * PI / 180.0) - micro_deg_ref + (pres_err * Kp_p + pres_err_sum * Ki_p + (pres_err - pres_err_prev) * Kd_p);
    //x = Al * cos(deg_ref_h * PI / 180.0) - micro_deg_ref;
    if (deg_ref_h >= 0.0) {
    y = sqrt(abs(pow(Al, 2) - pow(Al * cos(deg_ref_h * PI / 180.0) - micro_deg_ref, 2)));
    } else {
    y = -sqrt(abs(pow(Al, 2) - pow(Al * cos(deg_ref_h * PI / 180.0) - micro_deg_ref, 2)));
    }
    //deg_ref_h += micro_deg_ref; //目標角度更新

    deg_ref_h = atan2(y, x) * 180.0 / PI; //Δθ→Δx で目標角更新

    //誤差の計算

    err_curr_h = (deg_ref_h - deg_arm);

    if ( err_sum_h + err_curr_h >= -100 && err_sum_h + err_curr_h <= 100) {
    err_sum_h += err_curr_h;
    }

    vari += abs(err_curr_h);
    varian = vari / count_h;
    count_h ++;



    //アームのPID制御
    pwm_a = Kp_a * err_curr_h + Ki_a * err_sum_h + Kd_a * (err_curr_h - err_prev_h);


    //if (height_ref == 0.0) pwm_a = 0;
    //  if(deg_arm <-35 || deg_arm > 55 ){
    //    motor_a_set(0);
    //  }
    //  else{motor_a_set(-pwm_a);
    //  }
    motor_a_set(-pwm_a);

    //deg_prev_h = deg_curr_h;
    err_prev_h  = err_curr_h;
  */
  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  switch (judge) {
    case 1:
      if (height_ref_vari < height_ref) {
        height_ref_vari += 0.1 * 8; //*10*T_CTRL/1000;
      }
      break;
    case 2:
      if (height_ref_vari > height_ref) {
        height_ref_vari -= 0.1 * 8; //*10*T_CTRL/1000;
      }
      break;
  }



  err_curr_h = height_ref_vari - height;


  if ( err_sum_h + err_curr_h >= -50 && err_sum_h + err_curr_h <= 50) {
    err_sum_h += err_curr_h;
  }

  vari += abs(err_curr_h);
  varian = vari / count_h;
  count_h ++;



  pwm_a = Kp_a * err_curr_h + Ki_a * err_sum_h + Kd_a * (err_curr_h - err_prev_h);
  motor_a_set(-pwm_a);

  pres_err = 60.0 - pres_val;

  if ( pres_err_sum + pres_err >= -100000 && pres_err_sum + pres_err <= 100000) {
    pres_err_sum += pres_err;
  }
  

  const double Kp_p = 0.00001;//0.001;
  const double Ki_p = 0.0001;//0.005;
  const double Kd_p = 0.00;//0.005;


  body_curr = get_body_dist(height_ref_vari)/ 10 - (pres_err * Kp_p + pres_err_sum * Ki_p + (pres_err - pres_err_prev) * Kd_p) ; //[cm]

  distance_get(&d_l, &d_r);
  dist_curr_h  = (d_l + d_r) / 2.0;





  //ここから機体制御////////////////////////////////////////////////////////////////////////////////////////////////////////////////////




  /////機体制御//////////////////////////////////////////////////////////////////////////////////////////////////

  distance_get(&dist_curr_l_h, &dist_curr_r_h);
  //
  //  vel_curr_l_h = (dist_curr_l_h - dist_prev_l_h) / T_CTRL * 1000.0;
  //  vel_curr_r_h = (dist_curr_r_h - dist_prev_r_h) / T_CTRL * 1000.0;








  //err_curr_l_h = (vel_ref_l_h - vel_curr_l_h) ;//(run_ctrl.inoからの指令値) - (エンコーダから読み取って計算した実測値)
  //err_curr_r_h = (vel_ref_r_h - vel_curr_r_h) ;//

  err_curr_l_h = -(body_curr + dist_curr_l_h);
  err_curr_r_h = -(body_curr + dist_curr_r_h);

  if ( abs(err_sum_l_h + err_curr_l_h) < 60) {
    err_sum_l_h += err_curr_l_h;
  }
  if ( abs(err_sum_r_h + err_curr_r_h) < 60) {
    err_sum_r_h += err_curr_r_h;
  }
  
  pwm_l = Kp_b * err_curr_l_h + Ki_b * err_sum_l_h + Kd_b * (err_curr_l_h - err_prev_l_h);
  pwm_r = Kp_b * err_curr_r_h + Ki_b * err_sum_r_h + Kd_b * (err_curr_r_h - err_prev_r_h);

  //  if (vel_ref_l_h == 0.0) pwm_l = 0;
  //  if (vel_ref_r_h == 0.0) pwm_r = 0;
  //vel_ctrl_set(pwm_l/10.0,pwm_r/10.0);
  motor_set(pwm_l, pwm_r);
  //vel_ctrl_execute();


  dist_prev_l_h = dist_curr_l_h;
  dist_prev_r_h = dist_curr_r_h;
  err_prev_l_h  = err_curr_l_h;
  err_prev_r_h  = err_curr_r_h;

  pres_err_prev = pres_err;

}

void height_ctrl_set(double deg_ref, double height_vel_l, double height_vel_r) {
  height_ref = deg_ref;
  micro_deg_ref = deg_ref;
  vel_ref_r_h = height_vel_r;
  vel_ref_l_h = height_vel_l;

}



void height_ctrl_get(double * height_s) {
  get_deg_arm();
  *height_s = deg_arm;
}

void height_ctrl_reset() {
  err_curr_h = 0.0;
  err_prev_h   = 0.0;
  err_sum_h    = 0.0;
  dist_prev_l_h = 0.0;
  dist_prev_r_h = 0.0;
  err_prev_l_h  = 0.0;
  err_prev_r_h  = 0.0;
  err_sum_l_h   = 0.0;
  err_sum_r_h   = 0.0;
  vel_ref_l_h   = 0.0;
  vel_ref_r_h   = 0.0;

  pres_err = 0.0;
  pres_err_prev = 0.0;
  pres_err_sum = 0.0;

  dist_curr_l_h = 0.0;
  dist_curr_l_h = 0.0;
  dist_prev_l_h = 0.0;
  dist_prev_r_h = 0.0;
  err_prev_l_h  = 0.0;
  err_prev_r_h  = 0.0;
  err_curr_r_h = 0.0;
  err_curr_l_h = 0.0;
  //  dist_curr   = 0.0;
  //  dist_prev = 0.0;
  motor_a_set(0);
  motor_set(0, 0);
}
