/*
 *control FULL color LED WS2812
 *auther : 渡邊敬矢
 *ver.1.0 complete 10/13
 */
 


int R[5] = {0x00,0x00,0x80,0x00,0x00};
int G[5] = {0x00,0xff,0x01,0xff,0x00};
int B[5] = {0xff,0x00,0xFF,0xff,0xff};


const int LED_COUNT = 5;
Adafruit_NeoPixel pixels(LED_COUNT, PIN_LED, NEO_GRB + NEO_KHZ800);

//状態表示灯を初期化する。
 
void init_status_indicator()
{
    pinMode(PIN_LED, OUTPUT);
    //pixels.begin();
}

//状態表示灯を消灯する
 
void off_status_indicator()
{
    pixels.clear();
    for(int i = 0;i<60;i++){
      pixels.setPixelColor(4,pixels.Color(0,0,0));
    }
//    pixels.show();
}



//状態表示灯に状態をセットする
 
 
void set_status_indicator(int state)
{
    myservo.detach();
    pixels.begin();
    static int loopcount = 0;
    loopcount++;
    pixels.clear();
    if(state != HOMING){
        //点滅しないとき
        for(int i = 0;i<60;i++){
          pixels.setPixelColor(i,pixels.Color(R[state],G[state],B[state]));
        }
    }else{
        //点滅するとき
        if(loopcount>30){
          for(int i = 0;i<60;i++){
            pixels.setPixelColor(i,pixels.Color(0,0,200));
          }
        }else{
          for(int i = 0;i<60;i++){
            pixels.setPixelColor(i,pixels.Color(0,0,0));
          }
        }
    }
    pixels.show();
    if(loopcount>60)loopcount = 0;
    pixels.clear();
    myservo.attach(10);
}
